SystemOrganization addCategory: #'EjerciciosPoo-TusLibros'!

!MonthOfYear class methodsFor: '*EjerciciosPoo-TusLibros' stamp: 'BarroumeresLaje 6/17/2012 19:40'!
current
	|now|
	now := DateAndTime current.
	^self new initializeOnMonthNumber: now monthIndex of: now year.
	
	

	
! !

TestCase subclass: #TusLibrosTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-TusLibros'!

!TusLibrosTest methodsFor: 'Monetary values' stamp: 'BarroumeresLaje 6/18/2012 20:44'!
MPInterfaceDefault

	^MerchantProcessorInterface new.
! !

!TusLibrosTest methodsFor: 'Books' stamp: 'BarroumeresLaje 6/16/2012 21:02'!
book100MasDeUnSigloRojoYBlanco

	^'9789507543340'



! !

!TusLibrosTest methodsFor: 'Books' stamp: 'BarroumeresLaje 6/16/2012 21:02'!
bookLTA

	^'9789876480390'



! !

!TusLibrosTest methodsFor: 'Books' stamp: 'BarroumeresLaje 6/16/2012 21:02'!
bookSerDeRiver

	^'9789500737111'



! !

!TusLibrosTest methodsFor: 'Monetary values' stamp: 'BarroumeresLaje 6/16/2012 23:47'!
fiftyARS

	^MonetaryAmount of: 50 in: MonetaryCurrency ARS.
! !

!TusLibrosTest methodsFor: 'Monetary values' stamp: 'BarroumeresLaje 6/16/2012 23:47'!
oneHundredARS

	^MonetaryAmount of: 100 in: MonetaryCurrency ARS.
! !

!TusLibrosTest methodsFor: '1 - Cart manipulation' stamp: 'BarroumeresLaje 6/17/2012 21:40'!
test01CartShouldBeEmptyWhenCreated

	|aCart aCatalogue|
	aCatalogue := Dictionary new at: self bookLTA put: self fiftyARS; yourself.
	aCart := Cart withCatalogue: aCatalogue.

	self assert: aCart isEmpty.
	! !

!TusLibrosTest methodsFor: '1 - Cart manipulation' stamp: 'BarroumeresLaje 6/17/2012 22:51'!
test02CartIsNoLongerEmptyWhenAddingItems

	|aCart aCatalogue|
	aCatalogue := Dictionary new at: self bookLTA put: self fiftyARS; yourself.
	aCart := Cart withCatalogue: aCatalogue.
	aCart add: self bookLTA  quantity: 1.
	
	self deny: aCart isEmpty.
	! !

!TusLibrosTest methodsFor: '1 - Cart manipulation' stamp: 'BarroumeresLaje 6/17/2012 22:50'!
test03AddToCartAddTheCorrectAmountOfBooksToTheCart

	|aCart aCatalogue q|
	aCatalogue := Dictionary new at: self bookLTA put: self fiftyARS; yourself.
	aCart := Cart withCatalogue: aCatalogue.

	q := aCart quantityOf: self bookLTA  .
	aCart add: self bookLTA  quantity:  10.
	self assert: (aCart quantityOf: self bookLTA ) = (10 + q).
	
! !

!TusLibrosTest methodsFor: '1 - Cart manipulation' stamp: 'BarroumeresLaje 6/17/2012 23:43'!
test04CanNotAddNegativeQuantitiesOfItems

	|aCart aCatalogue q|
	aCatalogue := Dictionary new at: self bookLTA put: self fiftyARS; yourself.
	aCart := Cart withCatalogue: aCatalogue.
	
	q := aCart quantityOf: self bookLTA.
 	self should: [aCart add: self bookLTA  quantity: -1] raise: Error.
	self assert: q = (aCart quantityOf: self bookLTA).
	! !

!TusLibrosTest methodsFor: '1 - Cart manipulation' stamp: 'BarroumeresLaje 6/17/2012 22:57'!
test05CannotAddBooksFromAnotherPublisherToCart

	"Adding an item which is not in the catalogue should raise a NotFound exception"
	
	|aCart aCatalogue|
	aCatalogue := Dictionary new at: self bookLTA put: self fiftyARS; yourself.
	aCart := Cart withCatalogue: aCatalogue.

	self assert: (aCart quantityOf: self bookSerDeRiver) = 0.
	self deny: (aCatalogue includes: self bookSerDeRiver).
	self should: [ (Cart withCatalogue: aCatalogue) add: self bookSerDeRiver quantity: 1] raise: NotFound.
	self assert: (aCart quantityOf: self bookSerDeRiver) = 0.	


! !

!TusLibrosTest methodsFor: '1 - Cart manipulation' stamp: 'BarroumeresLaje 6/18/2012 20:46'!
test06CannotCheckoutWithAnInvalidNumberedCreditCard

	|catalogue cart aNonNumericCard aWrongSizeCard|
	catalogue := Dictionary new at: self bookLTA put: self fiftyARS;yourself.
	cart := (Cart withCatalogue: catalogue) add: self bookLTA  quantity: 1; yourself.

	aNonNumericCard := CreditCard ownedBy: 'Somebody' identifiedBy: 'aaaabbbbccccdddd' expiresOn: MonthOfYear current.
	aWrongSizeCard := CreditCard ownedBy: 'Somebody' identifiedBy: '11112222333344445' expiresOn: MonthOfYear current.
	
	
	self should: [ (Cashier withMerchantProcessorInterface: self MPInterfaceDefault) checkout: cart withCreditCard: aNonNumericCard] raise: Error
			withExceptionDo: [:anError | self assert: anError messageText = MerchantProcessorInterface errorMessageInvalidCardNumber].
	
	self should: [ (Cashier withMerchantProcessorInterface: self MPInterfaceDefault) checkout: cart withCreditCard: aWrongSizeCard] raise: Error
			withExceptionDo: [:anError | self assert: anError messageText = MerchantProcessorInterface errorMessageInvalidCardNumber].
	
	


! !

!TusLibrosTest methodsFor: '1 - Cart manipulation' stamp: 'BarroumeresLaje 6/18/2012 20:53'!
test07TotalPriceShouldBeGreaterThanZeroOnCheckout

	|aCatalogue aCart aValidCreditCard|
	aCatalogue := Dictionary new at: self bookLTA put: self zeroARS; yourself.
	aCart := (Cart withCatalogue: aCatalogue) add: self bookLTA  quantity: 100; yourself.
	aValidCreditCard := CreditCard ownedBy: 'Somebody' identifiedBy: '1111222233334444'  expiresOn: MonthOfYear current.
	
	self should: [(Cashier withMerchantProcessorInterface: self MPInterfaceDefault) checkout: aCart withCreditCard: aValidCreditCard] raise: Error  withExceptionDo: [:anError | self assert: anError messageText = MerchantProcessorInterface  errorMessageInvalidPrice].
	


! !

!TusLibrosTest methodsFor: '1 - Cart manipulation' stamp: 'BarroumeresLaje 6/18/2012 20:56'!
test08CannotCheckoutIfCardHasExpired

	"Adding an item which is not in the catalogue should raise a NotFound exception"

	|catalogue cart ccard|
	catalogue:=Dictionary new at: self book100MasDeUnSigloRojoYBlanco put: self oneHundredARS; yourself.
	cart := (Cart withCatalogue: catalogue) add: self book100MasDeUnSigloRojoYBlanco quantity: 3; yourself.
	ccard := CreditCard ownedBy: 'Somebody'  identifiedBy:  '1111222233334444' expiresOn: (MonthOfYear januaryOf: 1990).

	"En este caso como una tarjeta vencida se lo podria hasta considerar como parte normal del flujo de eventos modelados por el sistema, reificamos el error pues consideramos que es necesario identificarlo y hacer algo al respecto (por ejemplo, pedirle al cliente que provea otra tarjeta de credito)"
	self should: [ (Cashier withMerchantProcessorInterface: self MPInterfaceDefault) checkout: cart withCreditCard: ccard] raise: ExpiredCreditCardError.



! !

!TusLibrosTest methodsFor: '1 - Cart manipulation' stamp: 'BarroumeresLaje 6/17/2012 23:10'!
test09CannotCheckoutAnEmptyCart

	|catalogue cart ccard|
	catalogue := Dictionary new at: self bookLTA put: self fiftyARS; yourself.
	cart := Cart withCatalogue: catalogue.
	ccard := CreditCard ownedBy: 'Somebody' identifiedBy: '1111222233334444'  expiresOn: MonthOfYear current.
	
	self should: [ Cashier new checkout: cart withCreditCard: ccard] raise: Error
		withExceptionDo: [:anError | anError messageText = Cashier errorMessageEmptyCard]


! !

!TusLibrosTest methodsFor: '1 - Cart manipulation' stamp: 'BarroumeresLaje 6/17/2012 23:33'!
test10CheckoutKeepsCartInmutability

	|catalogue cart ccard itemsInCart catalogueInCart|
	catalogue := Dictionary new at: self bookLTA put: self fiftyARS; yourself.
	cart := (Cart withCatalogue: catalogue) add: self bookLTA  quantity: 5.
	ccard := CreditCard ownedBy: 'Somebody' identifiedBy: '1111222233334444'  expiresOn: MonthOfYear current.


	itemsInCart := cart purchasedItems .
	catalogueInCart := cart purchaseCatalogue .

	[Cashier new checkout: cart withCreditCard: ccard] on: Error do: [nil].
	
	self assert: (catalogueInCart  = cart purchaseCatalogue).
	self assert: (itemsInCart = cart purchasedItems).
	
		

! !

!TusLibrosTest methodsFor: '1 - Cart manipulation' stamp: 'BarroumeresLaje 6/17/2012 23:35'!
test11CheckoutKeepsCreditCardInmutability

	|catalogue cart ccard itemsInCart catalogueInCart|
	catalogue := Dictionary new at: self bookLTA put: self fiftyARS; yourself.
	cart := (Cart withCatalogue: catalogue) add: self bookLTA  quantity: 5.
	ccard := CreditCard ownedBy: 'Somebody' identifiedBy: '1111222233334444'  expiresOn: MonthOfYear current.

	[Cashier new checkout: cart withCreditCard: ccard] on: Error do: [nil].
	
	self assert: (ccard ownerName = 'Somebody').
	self assert: (ccard number = '1111222233334444').
	self assert: (ccard expirationDate = MonthOfYear current ).
	
	

	
		

! !

!TusLibrosTest methodsFor: 'Monetary values' stamp: 'BarroumeresLaje 6/17/2012 22:14'!
zeroARS

	^MonetaryAmount of: 0 in: MonetaryCurrency ARS.
! !

Error subclass: #TusLibrosError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-TusLibros'!

TusLibrosError subclass: #ExpiredCreditCardError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-TusLibros'!

Object subclass: #Cart
	instanceVariableNames: 'catalogue items'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-TusLibros'!

!Cart class methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 6/13/2012 21:41'!
withCatalogue: aSet 
	
	
	 ^self new initializeWithCatalogue: aSet 
	! !

!Cart methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 6/16/2012 21:05'!
add: anItem quantity: aNumber


	(catalogue includesKey: anItem) ifFalse: [^NotFound signal: 'No existe el articulo en el catalogo'].
	(aNumber >= 0) ifFalse: [^Error signal: 'Se deben agregar cantidades mayores a cero'].
	
	items add: anItem withOccurrences: aNumber.
	
	

	


	! !

!Cart methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 6/13/2012 21:48'!
initializeWithCatalogue: aSet


		catalogue:=aSet.
		items:=Bag new.! !

!Cart methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 6/16/2012 09:20'!
isEmpty

	^items isEmpty .
	! !

!Cart methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 6/17/2012 20:53'!
purchaseCatalogue

	^catalogue copy.
	! !

!Cart methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 6/17/2012 20:53'!
purchasedItems

	^items copy.
	


! !

!Cart methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 6/16/2012 09:31'!
quantityOf: anItem 

	^items occurrencesOf: anItem.
	
! !

Object subclass: #Cashier
	instanceVariableNames: 'myMerchantProcessorInterface'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-TusLibros'!

!Cashier class methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 6/17/2012 21:55'!
errorMessageEmptyCard 

	^'The cart is empty'! !

!Cashier class methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 6/18/2012 20:34'!
withMerchantProcessorInterface: aMerchantProcessorInterface


	^self new initializeWithMerchantProcessorInterface: aMerchantProcessorInterface.! !

!Cashier methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 6/18/2012 20:20'!
calculatePriceOf: purchasedItems over: aPurchaseCatalogue

	| totalValue |
	
	totalValue := purchasedItems inject: (MonetaryAmount of: 0  in: MonetaryCurrency ARS)  into: [:accum :anItem | 
		accum + (aPurchaseCatalogue at: anItem)].

	^totalValue.
	
	
	! !

!Cashier methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 6/18/2012 20:38'!
checkout: aCart withCreditCard: aCreditCard

	| totalPrice |

	myMerchantProcessorInterface validateCreditCard: aCreditCard.
	
	totalPrice := self calculatePriceOf: aCart purchasedItems over: aCart purchaseCatalogue.
	
	myMerchantProcessorInterface validateTotalPrice: totalPrice.

	
	"The next colaboration might fail for external reasons such as network failure, so exception handling should be done"
	MerchantProcessorInterface new debitFrom: aCreditCard theAmountOf: totalPrice onNetworkError: [^self shouldBeImplemented]
	


	
	
	
	
	! !

!Cashier methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 6/18/2012 20:35'!
initializeWithMerchantProcessorInterface: aMerchantProcessorInterface 


	myMerchantProcessorInterface := aMerchantProcessorInterface 
! !

Object subclass: #MerchantProcessorInterface
	instanceVariableNames: 'numberOfInvocations'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-TusLibros'!

!MerchantProcessorInterface class methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 6/18/2012 20:38'!
errorMessageInvalidCardNumber 

	^'Invalid card number'! !

!MerchantProcessorInterface class methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 6/18/2012 20:38'!
errorMessageInvalidPrice

	^'Negative price'! !

!MerchantProcessorInterface methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 6/17/2012 01:31'!
debitFrom: aCreditCard theAmountOf: aMonetaryAmount onNetworkError: aBlock

	^self shouldBeImplemented .! !

!MerchantProcessorInterface methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 6/18/2012 20:36'!
initialize


	numberOfInvocations := 0.
	
	
	
	
	
	! !

!MerchantProcessorInterface methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 6/18/2012 20:52'!
validateCreditCard: aCreditCard

	(aCreditCard isExpiredOn: MonthOfYear current) ifTrue:[^ExpiredCreditCardError signal: 'Tarjeta vencida'].
	(aCreditCard number matchesRegex: '[0-9]+') ifFalse: [^Error signal: MerchantProcessorInterface  errorMessageInvalidCardNumber].
	(aCreditCard number size = 16) ifFalse: [^Error signal: MerchantProcessorInterface  errorMessageInvalidCardNumber].
! !

!MerchantProcessorInterface methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 6/18/2012 20:56'!
validateTotalPrice: aMonetaryAmount 

	(aMonetaryAmount amount > 0) ifFalse: [^Error signal: MerchantProcessorInterface  errorMessageInvalidPrice].


	
	
	
	
	! !

Object subclass: #MonetaryAmount
	instanceVariableNames: 'currencyValue amountValue'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-TusLibros'!

!MonetaryAmount class methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 6/16/2012 20:10'!
of: anAmount in: aCurrency


^self new initializeWithAmount: anAmount in: aCurrency.
! !

!MonetaryAmount methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 6/18/2012 20:14'!
+ anotherMonetaryAmount

	^MonetaryAmount of: self amount * self currency exchangeRateValue + (anotherMonetaryAmount amount * anotherMonetaryAmount currency exchangeRateValue)   in: MonetaryCurrency ARS.
	! !

!MonetaryAmount methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 6/16/2012 23:32'!
amount 

	^amountValue
	! !

!MonetaryAmount methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 6/16/2012 23:32'!
currency

	^currencyValue ! !

!MonetaryAmount methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 6/16/2012 23:32'!
initializeWithAmount: anAmount  in: aCurrency


	amountValue := anAmount.
	currencyValue := aCurrency.
	! !

Object subclass: #MonetaryCurrency
	instanceVariableNames: 'name rate'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-TusLibros'!

!MonetaryCurrency class methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 6/16/2012 23:45'!
ARS

	^self named: 'ARS' withRate: 1.
	! !

!MonetaryCurrency class methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 6/18/2012 20:15'!
USD

	^self named: 'ARS' withRate: 4.5
	! !

!MonetaryCurrency class methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 6/16/2012 20:41'!
named: aName withRate: anExchangeRate

	^self new initializeWithName: aName rate: anExchangeRate.! !

!MonetaryCurrency methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 6/16/2012 23:33'!
exchangeRateValue

^rate.
! !

!MonetaryCurrency methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 6/16/2012 20:27'!
initializeWithName: aName rate: anExchangeRate


	name := aName.
	rate := anExchangeRate.! !
